package net.sourceforge.btrummer.nougatbytes.controller;

import net.sourceforge.btrummer.nougatbytes.model.Team;
import net.sourceforge.btrummer.nougatbytes.state.GameState;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@Controller
public class BackdoorController {

    private static final Logger LOG = LoggerFactory.getLogger(BackdoorController.class);

    @Autowired
    private GameState state;

    @RequestMapping(path = "/backdoor", method = GET)
    public String backdoor(@ModelAttribute("model") ModelMap model) {
        LOG.info("Showing backdoor to change the teams");

        model.put("teams", state.getTeams());

        return "backdoor";
    }

    @RequestMapping(path = "/backdoor/fix", method = POST)
    public String fixTeam(@RequestParam("id") int id,
                          @RequestParam("name") String name,
                          @RequestParam("score") int score,
                          @ModelAttribute("model") ModelMap model) {
        LOG.info("Fixing team {} name to '{}' and score to {}", id, name, score);

        Team team = state.getTeam(id);
        team.setName(name);
        team.setScore(score);

        return "redirect:/backdoor";
    }
}
