package net.sourceforge.btrummer.nougatbytes.model;

public class TeamBuilder {

    private final int id;
    private String name;
    private Color color;

    private TeamBuilder(int id) {
        this.id = id;
    }

    public static TeamBuilder team(int id) {
        return new TeamBuilder(id);
    }

    public TeamBuilder withName(String name) {
        this.name = name;
        return this;
    }

    public TeamBuilder withColor(Color color) {
        this.color = color;
        return this;
    }

    public Team build() {
        Team team = new Team(id);
        team.setName(name);
        team.setColor(color);
        return team;
    }
}
